Unit trsa1r_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, RSA1R_p;

function trsa1r: String;

implementation

function trsa1r: String;
var
N,M,_i,IFLAG :Integer;
RESP :Array [0..15] of Real;
ANS :Array [0..31] of Real;
FFT :Array [0..15] of Complex;
_car :Array of Complex;   //  
const
ARRAY_ :Array [0..15] of Real = ( 0.0,0.0,0.5,0.0,0.0,-0.5,0.0,0.0,0.5,0.5,0.5,
0.5,0.5,0.0,0.0,0.0 );
begin
for _i:=0 to 15 do
 begin
  FFT[_i].re := 0.0;
  FFT[_i].im := 0.0;
  RESP[_i] := 0.0;
 end;

SetLength(_car,(High(ANS)+1) div 2);  //   

Result := '';  {   }
N := 16;
M := 3;
RESP[0] := 0.7;
RESP[1] := 0.4;
RESP[2] := 0.4;
//RSA1R(ARRAY_,N,RESP,M,ANS,FFT,1,IFLAG);
for _i:=0 to High(_car) do
 begin
  _car[_i].re := 0.0; //  
  _car[_i].im := 0.0; //  
 end;
RSA1R(ARRAY_,N,RESP,M,_car,FFT,1,IFLAG);
for _i:=0 to High(_car) do
 begin
  ANS[2*_i] := _car[_i].re; //  
  ANS[2*_i + 1] := _car[_i].im; //  
 end;

Result := Result + Format('%5d ',[IFLAG]) + #$0D#$0A;
Result := Result + #$0D#$0A;
for _i:=0 to 31 do
 begin
  Result := Result + Format('%20.16f ',[ANS[_i]]);
  if ( ((_i+1) mod 4)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
UtRes('trsa1r',Result);  {     trsa1r.res }
exit;
end;

end.
